﻿using System;
using System.Windows.Forms;
using System.IO.Ports;
using System.Media;

namespace SerialReader
{

    /*
     * N.B.:
     * in Linux va aggiunto l'utente che usa Arduino al group dialout con il comando
     * sudo adduser ospite dialout
     * 
     * per dare il permesso di accesso 
     * sudo chmod 666 ttyUSB0
     */

    public partial class Form1 : Form
    {
        Timer timer;
        SoundPlayer player;


        public Form1()
        {
            InitializeComponent();
            txtPorta.Text = "/dev/ttyUSB0";

            player = new SoundPlayer();

            timer = new Timer();
            timer.Interval = 500;
            timer.Enabled = false;
            timer.Tick += (sender, e) => {              
                if (serialPort1.IsOpen) 
                {
                    string nota = serialPort1.ReadLine();
                    player.SoundLocation = nota+ "1.wav";
                    player.Play();
                    lbxLog.Items.Add("Nota = " + nota);
                }
                Application.DoEvents();
            };
        }

        private void btnApriSeriale_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen)
                serialPort1.Close();

            serialPort1.PortName = txtPorta.Text;
            try
            {
                serialPort1.Open();
                lbxLog.Items.Clear();
                lbxLog.Items.Add($"Porta seriale {txtPorta.Text} aperta");
                timer.Enabled = true;
            }
            catch(Exception errore)
            {
                MessageBox.Show("Si è verificato un errore: "+ errore.Message, "Errore", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void btnChiudiSeriale_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen)
            {
                timer.Enabled = false;
                serialPort1.Close();
                lbxLog.Items.Add($"Porta seriale {txtPorta.Text} chiusa");
            }
        }

    }
}
